/**
@breef Criao das funes para a converso da rvore de descio.
@Lincence LGPL
@Author Julio Alberto Aranis Contreras
@Date 26/05/2007

@breef
@Author 
@Date 
**/

#include <iostream>
#include <fstream>
#include <string>
#include <queue>
using namespace std;

bool existInQueue(string value,queue<string> q){
	int size = q.size();
	for(int i=0;i<size;++i){
		if(q.front()==value){
			return true;
		}
		q.pop();
	}
	return false;
}

#define DEFINE "#define "
void createDefines(const char* file,queue<string>* result){
	queue<string> define;
	string line="";
	string value="";

	fstream arq;
	arq.open(file,ios::in);
	while(!arq.eof()){
		arq >> value;
		if((value[0] == '(')){
			line = "";
		}else
		if(value == "|"){
			line = "";
		}else
		if(value == "="){
			arq >> value;
			if(! existInQueue(value,define)){
				define.push(value);
			}
			line="";
		}else	
		if(value == ":"){
			arq >> value;
			if(! existInQueue(value,define)){
				define.push(value);
			}
		}
		/*
		else
		if(value != "|"){
			if(! existInQueue(value,define)){
				define.push(value);
			}
		}
		*/
	}
	arq.close;
	result->push("");
	int size = define.size();
	for(int i=0;i<size;++i){
		result->push(DEFINE+define.front()+" 0");
		define.pop();
	}
	result->push("");
};


/**
@breef Carrega os resultados da vore de deciso.
*/
void loadResult(const char* file,string variable1,string variable2,queue<string>* result){
	fstream arq;
	arq.open(file,ios::in);
	string value;
	string line="";
	int count=0;

	createDefines(file,result);

	//cria a funo
	result->push("void out(){");
	while(!arq.eof()){
		value="";
		arq >> value;
		if((value[0] == '(')){
			line = "";
		}else
		if(value == "|"){
			line += "	";
		}else
		if(value == "="){
			arq >> value;
			line+= " == "+value+"){";
			result->push(line);
			line="";
		}else	
		if(value == ":"){
			arq >> value;
			int size = count;
			for(int i=0;i<size+1;++i){
				line +="	";
			} 
			line += variable2+" = "+value+";";
			result->push(line);
			line ="";
			for(int i=0;i<size;++i){
				line +="	";
			} 
			for(int i=0;i<size;++i){
				line +="}";
				count--;
			} 
			line +="else";
			result->push(line);
			line="";
		}else
		if(value != "|"){
			count++;
			line += "if("+variable1+value;
		}
	}
	result->push("{}");
	result->push("}");
	arq.close();
}


void createFile(const char* file,queue<string> result){
	fstream arq;
	arq.open(file,ios::out);
	int size=result.size();
	for(int i=0;i<size;++i){
		arq << result.front() << endl;
		result.pop() ;
	}
	arq.close();
}

void show(queue<string> result){
	int size=result.size();
	for(int i=0;i<size;++i){
		cout << result.front() << endl;
		result.pop();
	}
}

int main(int argc, char **argv){
	if(argc == 4){
		queue<string> result;
		const char* file = argv[1];
		string fileOut= file;
		fileOut +="out.h";
		string variable1 =argv[2];
		string variable2 =argv[3];
		loadResult(file,variable1,variable2,&result);
		createFile(fileOut.c_str(),result);
		show(result);	
	}else{
		cout << "InterpretTree.exe file nameVariableIf nameVariableResult " << endl;
		cout << endl;
		system("pause");
	}
}